## Index

### Classes

- ConfigModel

### Type Aliases

- APIConfig
- Circle
- Configuration
- ExternalOGCServer
- Fill
- GridMergeTabs
- LayerConfig
- LineConfiguration
- MapConfig
- MeasureRasterLayer
- MousePositionProjection
- OptionsLegendType
- Projection
- RegularShape
- RoutingProfile
- SearchAction
- SearchComponentDatasource
- StringToHtmlReplacement
- Stroke
- Style
- StyleLike
- View
- WfsType
- authenticationBaseUrl
- defaultLang
- fulltextsearchUrl
- gmfAuthenticationConfig
- gmfAuthenticationNoReloadRole
- gmfBackgroundLayerSelectorOptions
- gmfContextualDataOptions
- gmfCsvFilename
- gmfCustomCSS
- gmfCustomJavascriptUrl
- gmfCustomStylesheetUrl
- gmfDisclaimerOptions
- gmfDisplayQueryGridOptions
- gmfDisplayQueryWindowOptions
- gmfEditFeatureOptions
- gmfElevationOptions
- gmfExternalOGCServers
- gmfFloors
- gmfLayerTreeOptions
- gmfLayersUrl
- gmfMobileMeasureAreaOptions
- gmfMobileMeasureLengthOptions
- gmfMobileMeasurePointOptions
- gmfMousePositionOptions
- gmfObjectEditingToolsOptions
- gmfOptions
- gmfPermalinkOptions
- gmfPrintOptions
- gmfPrintUrl
- gmfProfileJsonUrl
- gmfProfileOptions
- gmfProjectionsOptions
- gmfQueryGrid
- gmfRasterUrl
- gmfSearchGroups
- gmfSearchOptions
- gmfShareOptions
- gmfShortenerCreateUrl
- gmfSnappingOptions
- gmfThemesOptions
- gmfTreeManagerModeFlush
- gmfTreeUrl
- gmfTwoFactorAuth
- langUrls
- ngeoCsvEncoding
- ngeoCsvExtension
- ngeoCsvIncludeHeader
- ngeoCsvQuote
- ngeoCsvSeparator
- ngeoGeolocationOptions
- ngeoMeasureDecimals
- ngeoMeasurePrecision
- ngeoMeasureSpherical
- ngeoNominatimSearchDefaultParams
- ngeoOfflineTestUrl
- ngeoPermalinkOgcserverUrl
- ngeoPointfilter
- ngeoProfileOptions
- ngeoQueryOptions
- ngeoRoutingOptions
- ngeoScaleSelectorOptions
- ngeoSnappingTolerance
- ngeoStreetviewOptions
- ngeoStringToHtmlReplacements
- ngeoTilesPreloadingLimit
- ngeoUsedKeyRegexp
- ngeoWfsPermalinkOptions
- pytreeLidarprofileJsonUrl

### Variables

- default

### Functions

- buildStyle

## Type Aliases

### APIConfig

APIConfig: { backgroundLayer?: string; extent?: number[]; localeUrl?: string; projection?: string; projections?: {}; queryableLayers?: string[]; resolutions?: number[]; searchUrl?: string; themesUrl?: string }

- Defined in config.ts:1452

#### Type declaration

- ##### Optional backgroundLayer?: string

- ##### Optional extent?: number[]

- ##### Optional localeUrl?: string

- ##### Optional projection?: string

- ##### Optional projections?: {}

  - ##### [x: string]: Projection

- ##### Optional queryableLayers?: string[]

- ##### Optional resolutions?: number[]

- ##### Optional searchUrl?: string

- ##### Optional themesUrl?: string

### Circle

Circle: { displacement?: number[]; fill?: Fill; radius: number; stroke?: Stroke }

- Defined in config.ts:143

#### Type declaration

- ##### Optional displacement?: number[]

  displacement

- ##### Optional fill?: Fill

  Fill style.

- ##### radius: number

  Circle radius.

- ##### Optional stroke?: Stroke

  Stroke style.

### Configuration

Configuration: { authenticationBaseUrl: authenticationBaseUrl; gmfAuthenticationConfig: gmfAuthenticationConfig; gmfAuthenticationNoReloadRole: gmfAuthenticationNoReloadRole; gmfBackgroundLayerSelectorOptions: gmfBackgroundLayerSelectorOptions; gmfContextualDataOptions: gmfContextualDataOptions; gmfCsvFilename: gmfCsvFilename; gmfCustomCSS: gmfCustomCSS; gmfCustomJavascriptUrl: gmfCustomJavascriptUrl; gmfCustomStylesheetUrl: gmfCustomStylesheetUrl; gmfDisclaimerOptions: gmfDisclaimerOptions; gmfDisplayQueryGridOptions: gmfDisplayQueryGridOptions; gmfDisplayQueryWindowOptions: gmfDisplayQueryWindowOptions; gmfEditFeatureOptions: gmfEditFeatureOptions; gmfElevationOptions: gmfElevationOptions; gmfExternalOGCServers: gmfExternalOGCServers; gmfFloors: gmfFloors; gmfI18nextConfiguration: InitOptions; gmfLayerTreeOptions: gmfLayerTreeOptions; gmfLayersUrl: gmfLayersUrl; gmfMobileMeasureAreaOptions: gmfMobileMeasureAreaOptions; gmfMobileMeasureLengthOptions: gmfMobileMeasureLengthOptions; gmfMobileMeasurePointOptions: gmfMobileMeasurePointOptions; gmfMousePositionOptions: gmfMousePositionOptions; gmfObjectEditingToolsOptions: gmfObjectEditingToolsOptions; gmfOptions: gmfOptions; gmfPermalinkOptions: gmfPermalinkOptions; gmfPrintOptions: gmfPrintOptions; gmfPrintUrl: gmfPrintUrl; gmfProfileJsonUrl: gmfProfileJsonUrl; gmfProfileOptions: gmfProfileOptions; gmfProjectionsOptions: gmfProjectionsOptions; gmfQueryGrid: gmfQueryGrid; gmfRasterUrl: gmfRasterUrl; gmfSearchGroups: gmfSearchGroups; gmfSearchOptions: gmfSearchOptions; gmfShareOptions: gmfShareOptions; gmfShortenerCreateUrl: gmfShortenerCreateUrl; gmfSnappingOptions: gmfSnappingOptions; gmfThemesOptions: gmfThemesOptions; gmfTreeManagerModeFlush: gmfTreeManagerModeFlush; gmfTreeUrl: gmfTreeUrl; gmfTwoFactorAuth: gmfTwoFactorAuth; ngeoCsvEncoding: ngeoCsvEncoding; ngeoCsvExtension: ngeoCsvExtension; ngeoCsvIncludeHeader: ngeoCsvIncludeHeader; ngeoCsvQuote: ngeoCsvQuote; ngeoCsvSeparator: ngeoCsvSeparator; ngeoGeolocationOptions: ngeoGeolocationOptions; ngeoMeasureDecimals: ngeoMeasureDecimals; ngeoMeasurePrecision: ngeoMeasurePrecision; ngeoMeasureSpherical: ngeoMeasureSpherical; ngeoNominatimSearchDefaultParams: ngeoNominatimSearchDefaultParams; ngeoOfflineTestUrl: ngeoOfflineTestUrl; ngeoPermalinkOgcserverUrl: ngeoPermalinkOgcserverUrl; ngeoPointfilter: ngeoPointfilter; ngeoProfileOptions: ngeoProfileOptions; ngeoQueryOptions: ngeoQueryOptions; ngeoRoutingOptions: ngeoRoutingOptions; ngeoScaleSelectorOptions: ngeoScaleSelectorOptions; ngeoSnappingTolerance: ngeoSnappingTolerance; ngeoStreetviewOptions: ngeoStreetviewOptions; ngeoStringToHtmlReplacements: ngeoStringToHtmlReplacements; ngeoTilesPreloadingLimit: ngeoTilesPreloadingLimit; ngeoUsedKeyRegexp: ngeoUsedKeyRegexp; ngeoWfsPermalinkOptions: ngeoWfsPermalinkOptions; pytreeLidarprofileJsonUrl: pytreeLidarprofileJsonUrl }

- Defined in config.ts:1383

The full configuration

#### Type declaration

- ##### authenticationBaseUrl: authenticationBaseUrl

- ##### gmfAuthenticationConfig: gmfAuthenticationConfig

- ##### gmfAuthenticationNoReloadRole: gmfAuthenticationNoReloadRole

- ##### gmfBackgroundLayerSelectorOptions: gmfBackgroundLayerSelectorOptions

- ##### gmfContextualDataOptions: gmfContextualDataOptions

- ##### gmfCsvFilename: gmfCsvFilename

- ##### gmfCustomCSS: gmfCustomCSS

- ##### gmfCustomJavascriptUrl: gmfCustomJavascriptUrl

- ##### gmfCustomStylesheetUrl: gmfCustomStylesheetUrl

- ##### gmfDisclaimerOptions: gmfDisclaimerOptions

- ##### gmfDisplayQueryGridOptions: gmfDisplayQueryGridOptions

- ##### gmfDisplayQueryWindowOptions: gmfDisplayQueryWindowOptions

- ##### gmfEditFeatureOptions: gmfEditFeatureOptions

- ##### gmfElevationOptions: gmfElevationOptions

- ##### gmfExternalOGCServers: gmfExternalOGCServers

- ##### gmfFloors: gmfFloors

- ##### gmfI18nextConfiguration: InitOptions

- ##### gmfLayerTreeOptions: gmfLayerTreeOptions

- ##### gmfLayersUrl: gmfLayersUrl

- ##### gmfMobileMeasureAreaOptions: gmfMobileMeasureAreaOptions

- ##### gmfMobileMeasureLengthOptions: gmfMobileMeasureLengthOptions

- ##### gmfMobileMeasurePointOptions: gmfMobileMeasurePointOptions

- ##### gmfMousePositionOptions: gmfMousePositionOptions

- ##### gmfObjectEditingToolsOptions: gmfObjectEditingToolsOptions

- ##### gmfOptions: gmfOptions

- ##### gmfPermalinkOptions: gmfPermalinkOptions

- ##### gmfPrintOptions: gmfPrintOptions

- ##### gmfPrintUrl: gmfPrintUrl

- ##### gmfProfileJsonUrl: gmfProfileJsonUrl

- ##### gmfProfileOptions: gmfProfileOptions

- ##### gmfProjectionsOptions: gmfProjectionsOptions

- ##### gmfQueryGrid: gmfQueryGrid

- ##### gmfRasterUrl: gmfRasterUrl

- ##### gmfSearchGroups: gmfSearchGroups

- ##### gmfSearchOptions: gmfSearchOptions

- ##### gmfShareOptions: gmfShareOptions

- ##### gmfShortenerCreateUrl: gmfShortenerCreateUrl

- ##### gmfSnappingOptions: gmfSnappingOptions

- ##### gmfThemesOptions: gmfThemesOptions

- ##### gmfTreeManagerModeFlush: gmfTreeManagerModeFlush

- ##### gmfTreeUrl: gmfTreeUrl

- ##### gmfTwoFactorAuth: gmfTwoFactorAuth

- ##### ngeoCsvEncoding: ngeoCsvEncoding

- ##### ngeoCsvExtension: ngeoCsvExtension

- ##### ngeoCsvIncludeHeader: ngeoCsvIncludeHeader

- ##### ngeoCsvQuote: ngeoCsvQuote

- ##### ngeoCsvSeparator: ngeoCsvSeparator

- ##### ngeoGeolocationOptions: ngeoGeolocationOptions

- ##### ngeoMeasureDecimals: ngeoMeasureDecimals

- ##### ngeoMeasurePrecision: ngeoMeasurePrecision

- ##### ngeoMeasureSpherical: ngeoMeasureSpherical

- ##### ngeoNominatimSearchDefaultParams: ngeoNominatimSearchDefaultParams

- ##### ngeoOfflineTestUrl: ngeoOfflineTestUrl

- ##### ngeoPermalinkOgcserverUrl: ngeoPermalinkOgcserverUrl

- ##### ngeoPointfilter: ngeoPointfilter

- ##### ngeoProfileOptions: ngeoProfileOptions

- ##### ngeoQueryOptions: ngeoQueryOptions

- ##### ngeoRoutingOptions: ngeoRoutingOptions

- ##### ngeoScaleSelectorOptions: ngeoScaleSelectorOptions

- ##### ngeoSnappingTolerance: ngeoSnappingTolerance

- ##### ngeoStreetviewOptions: ngeoStreetviewOptions

- ##### ngeoStringToHtmlReplacements: ngeoStringToHtmlReplacements

- ##### ngeoTilesPreloadingLimit: ngeoTilesPreloadingLimit

- ##### ngeoUsedKeyRegexp: ngeoUsedKeyRegexp

- ##### ngeoWfsPermalinkOptions: ngeoWfsPermalinkOptions

- ##### pytreeLidarprofileJsonUrl: pytreeLidarprofileJsonUrl

### ExternalOGCServer

ExternalOGCServer: { name: string; type: string; url: string }

- Defined in config.ts:987

The definition of an external OGC server

#### Type declaration

- ##### name: string

- ##### type: string

- ##### url: string

### Fill

Fill: { color?: number[] | string }

- Defined in config.ts:55

#### Type declaration

- ##### Optional color?: number[] | string

  The color.

### GridMergeTabs

GridMergeTabs: {}

- Defined in config.ts:1055

Configuration option for {@link import('gmf/query/gridComponent').GmfQueryGridComponent} to merge grid tabs.

E.g. `'two_wheels_park': ['velo_park', 'moto_park']}` merges the sources with label `velo_park` and `moto_park` into a new source `two_wheels_park`.

#### Type declaration

- ##### [x: string]: string[]

### LayerConfig

LayerConfig: { args?: string[]; filter?: string; postfix?: string; separator?: string }

- Defined in config.ts:1109

#### Type declaration

- ##### Optional args?: string[]

- ##### Optional filter?: string

- ##### Optional postfix?: string

- ##### Optional separator?: string

### LineConfiguration

LineConfiguration: { color?: string; zExtractor: ZExtractorFunction }

- Defined in config.ts:478

Configuration object for one profile's line.

#### Type declaration

- ##### Optional color?: string

  Color of the line (hex color string).

- ##### zExtractor: ZExtractorFunction

  Extract the elevation of a point (an item of the elevation data array).

### MapConfig

MapConfig: { maxTilesLoading?: number; moveTolerance?: number; pixelRatio?: number }

- Defined in config.ts:763

The map definition.

#### Type declaration

- ##### Optional maxTilesLoading?: number

  Maximum number tiles to load simultaneously.

- ##### Optional moveTolerance?: number

  The minimum distance in pixels the cursor must move to be detected as a map move event instead of a click. Increasing this value can make it easier to click on the map.

- ##### Optional pixelRatio?: number

  The ratio between physical pixels and device-independent pixels (dips) on the device.

### MeasureRasterLayer

MeasureRasterLayer: { decimals?: number; name: string; unit?: string }

- Defined in config.ts:1288

#### Type declaration

- ##### Optional decimals?: number

- ##### name: string

- ##### Optional unit?: string

### MousePositionProjection

MousePositionProjection: { code: string; filter: string; label: string }

- Defined in config.ts:1243

Projection object for the MousePositionDirective. Define a label and a filter to use to display coordinates for a projection.

#### Type declaration

- ##### code: string

  The epsg name of a projection.

- ##### filter: string

  The filter function to use to format this projection. Arguments can be passed with colon as separator (example: MyFilter:args1:args2:...)

- ##### label: string

  The label to display with this projection.

### OptionsLegendType

OptionsLegendType: { label: {}; params: {}; showGroupsTitle?: boolean; useBbox?: boolean }

- Defined in config.ts:893

#### Type declaration

- ##### label: {}

  The key is the server type (`mapserver`, `qgis`, ...), if the value is `false` the name of the layer will be not displayed. This is used to avoid duplicated title, as text and in the legend image.

  - ##### [x: string]: boolean

- ##### params: {}

  The key is the server type (`mapserver`, `qgis`, ...) or `image` for an URL from a metadata. The value is some additional parameters set in the query string.

  - ##### [x: string]: {}

    - ##### [x: string]: string

- ##### Optional showGroupsTitle?: boolean

  Display or not groups title in the legend. default is true. Switching to false is useful to obtains a "flat" legend.

- ##### Optional useBbox?: boolean

  Use or not the bbox. Default to true. For QGIS server only.

### Projection

Projection: { definition: string[]; extent: number[] }

- Defined in config.ts:44

A projection definitions.

#### Type declaration

- ##### definition: string[]

  The definition.

- ##### extent: number[]

  The extent.

### RegularShape

RegularShape: { angle?: number; displacement?: number[]; fill?: Fill; points: number; radius?: number; radius1?: number; radius2?: number; rotateWithView?: boolean; rotation?: number; stroke?: Stroke }

- Defined in config.ts:99

Specify radius for regular polygons, or radius1 and radius2 for stars. See also: https://openlayers.org/en/latest/examples/regularshape.html

#### Type declaration

- ##### Optional angle?: number

  Shape's angle in radians. A value of 0 will have one of the shape's point facing up.

- ##### Optional displacement?: number[]

  Displacement of the shape

- ##### Optional fill?: Fill

  Fill style.

- ##### points: number

  Number of points for stars and regular polygons. In case of a polygon, the number of points is the number of sides.

- ##### Optional radius?: number

  Radius of a regular polygon.

- ##### Optional radius1?: number

  Outer radius of a star.

- ##### Optional radius2?: number

  Inner radius of a star.

- ##### Optional rotateWithView?: boolean

  Whether to rotate the shape with the view.

- ##### Optional rotation?: number

  Rotation in radians (positive rotation clockwise).

- ##### Optional stroke?: Stroke

  Stroke style.

### RoutingProfile

RoutingProfile: { label: string; profile: string }

- Defined in config.ts:319

#### Type declaration

- ##### label: string

- ##### profile: string

### SearchAction

SearchAction: { action: string; title: string }

- Defined in config.ts:1146

#### Type declaration

- ##### action: string

  The action

- ##### title: string

  The title

### SearchComponentDatasource

SearchComponentDatasource: { bloodhoundOptions?: Bloodhound.BloodhoundOptions<GeoJSON.FeatureCollection>; datasetTitle?: string; groupActions?: SearchAction[]; groupValues?: string[]; labelKey: string; projection?: string; typeaheadDatasetOptions?: Twitter.Typeahead.Dataset<OlFeature<OlGeomGeometry>>; url?: string }

- Defined in config.ts:1160

Datasource configuration options for the search directive.

#### Type declaration

- ##### Optional bloodhoundOptions?: Bloodhound.BloodhoundOptions<GeoJSON.FeatureCollection>

  The optional Bloodhound configuration for this data set. See: https://github.com/twitter/typeahead.js/blob/master/doc/bloodhound.md

- ##### Optional datasetTitle?: string

- ##### Optional groupActions?: SearchAction[]

  List of allowed actions. The list may contain a combination of `add_theme`, `add_group` or `add_layer`

- ##### Optional groupValues?: string[]

  Possible values for the 'layer_name' key. Used to define groups of dataset.

- ##### labelKey: string

  The name of a corresponding GeoJSON property key in the current dataset. The bound value of this property key will be used as label.

- ##### Optional projection?: string

  The geometry's projection for this set of data.

- ##### Optional typeaheadDatasetOptions?: Twitter.Typeahead.Dataset<OlFeature<OlGeomGeometry>>

  The optional Twitter.Typeahead. configuration for this dataset. See: https://github.com/twitter/typeahead.js/blob/master/

- ##### Optional url?: string

  URL of the search service. Must contain a '%QUERY' term that will be replaced by the input string.

### StringToHtmlReplacement

StringToHtmlReplacement: { compiled_expression?: RegExp; expression: string; flags?: string; template: string }

- Defined in config.ts:329

#### Type declaration

- ##### Optional compiled_expression?: RegExp

  Internal: the compiled regular expression.

- ##### expression: string

  The regexp expression that must match to do the replacement.

- ##### Optional flags?: string

  The regexp flags.

- ##### template: string

  The template to use to create a new value as replacement if the regex matches.

### Stroke

Stroke: { color?: number[] | string; lineCap?: CanvasLineCap; lineDash?: number[]; lineDashOffset?: number; lineJoin?: CanvasLineJoin; miterLimit?: number; width?: number }

- Defined in config.ts:62

#### Type declaration

- ##### Optional color?: number[] | string

  The color.

- ##### Optional lineCap?: CanvasLineCap

  Line cap style: `butt`, `round`, or `square`.

- ##### Optional lineDash?: number[]

  Line dash pattern. Default is `null` (no dash). Please note that Internet Explorer 10 and lower do not support the `setLineDash` method on the `CanvasRenderingContext2D` and therefore this option will have no visual effect in these browsers.

- ##### Optional lineDashOffset?: number

  Line dash offset.

- ##### Optional lineJoin?: CanvasLineJoin

  Line join style: `bevel`, `round`, or `miter`.

- ##### Optional miterLimit?: number

  Miter limit.

- ##### Optional width?: number

  Width.

### Style

Style: { circle?: Circle; fill?: Fill; regularShape?: RegularShape; stroke?: Stroke; zIndex?: number }

- Defined in config.ts:165

The style description.

#### Type declaration

- ##### Optional circle?: Circle

  The circle config.

- ##### Optional fill?: Fill

  The fill color.

- ##### Optional regularShape?: RegularShape

  The regular shape config.

- ##### Optional stroke?: Stroke

  The stoke config.

- ##### Optional zIndex?: number

  The z index.

### StyleLike

StyleLike: OlStyleStyleStyleLike | Style[] | Style

- Defined in config.ts:188

### View

View: { center?: number[]; constrainOnlyCenter?: boolean; constrainResolution?: boolean; constrainRotation?: boolean | number; enableRotation?: boolean; extent?: number[]; maxResolution?: number; maxZoom?: number; minResolution?: number; minZoom?: number; multiWorld?: boolean; projection: string; resolution?: number; resolutions?: number[]; rotation?: number; showFullExtent?: boolean; smoothExtentConstraint?: boolean; smoothResolutionConstraint?: boolean; zoom?: number; zoomFactor?: number }

- Defined in config.ts:625

The view definition.

#### Type declaration

- ##### Optional center?: number[]

  The initial center for the view. If a user projection is not set, the coordinate system for the center is specified with the `projection` option. Layer sources will not be fetched if this is not set, but the center can be set later with {@link #setCenter}.

- ##### Optional constrainOnlyCenter?: boolean

  If true, the extent constraint will only apply to the view center and not the whole extent.

- ##### Optional constrainResolution?: boolean

  If true, the view will always animate to the closest zoom level after an interaction; false means intermediary zoom levels are allowed.

- ##### Optional constrainRotation?: boolean | number

  Rotation constraint. `false` means no constraint. `true` means no constraint, but snap to zero near zero. A number constrains the rotation to that number of values. For example, `4` will constrain the rotation to 0, 90, 180, and 270 degrees.

- ##### Optional enableRotation?: boolean

  Enable rotation. If `false`, a rotation constraint that always sets the rotation to zero is used. The `constrainRotation` option has no effect if `enableRotation` is `false`.

- ##### Optional extent?: number[]

  The extent that constrains the view, in other words, nothing outside of this extent can be visible on the map.

- ##### Optional maxResolution?: number

  The maximum resolution used to determine the resolution constraint. It is used together with `minResolution` (or `maxZoom`) and `zoomFactor`. If unspecified it is calculated in such a way that the projection's validity extent fits in a 256x256 px tile. If the projection is Spherical Mercator (the default) then `maxResolution` defaults to `40075016.68557849 / 256 = 156543.03392804097`.

- ##### Optional maxZoom?: number

  The maximum zoom level used to determine the resolution constraint. It is used together with `minZoom` (or `maxResolution`) and `zoomFactor`. Note that if `minResolution` is also provided, it is given precedence over `maxZoom`.

- ##### Optional minResolution?: number

  The minimum resolution used to determine the resolution constraint. It is used together with `maxResolution` (or `minZoom`) and `zoomFactor`. If unspecified it is calculated assuming 29 zoom levels (with a factor of 2). If the projection is Spherical Mercator (the default) then `minResolution` defaults to `40075016.68557849 / 256 / Math.pow(2, 28) = 0.0005831682455839253`.

- ##### Optional minZoom?: number

  The minimum zoom level used to determine the resolution constraint. It is used together with `maxZoom` (or `minResolution`) and `zoomFactor`. Note that if `maxResolution` is also provided, it is given precedence over `minZoom`.

- ##### Optional multiWorld?: boolean

  If `false` the view is constrained so only one world is visible, and you cannot pan off the edge. If `true` the map may show multiple worlds at low zoom levels. Only used if the `projection` is global. Note that if `extent` is also provided it is given precedence.

- ##### projection: string

  The main projection.

- ##### Optional resolution?: number

  The initial resolution for the view. The units are `projection` units per pixel (e.g. meters per pixel). An alternative to setting this is to set `zoom`. Layer sources will not be fetched if neither this nor `zoom` are defined, but they can be set later with {@link #setZoom} or {@link #setResolution}.

- ##### Optional resolutions?: number[]

  Resolutions to determine the resolution constraint. If set the `maxResolution`, `minResolution`, `minZoom`, `maxZoom`, and `zoomFactor` options are ignored.

- ##### Optional rotation?: number

  The initial rotation for the view in radians (positive rotation clockwise, 0 means North).

- ##### Optional showFullExtent?: boolean

  Allow the view to be zoomed out to show the full configured extent. By default, when a view is configured with an extent, users will not be able to zoom out so the viewport exceeds the extent in either dimension. This means the full extent may not be visible if the viewport is taller or wider than the aspect ratio of the configured extent. If showFullExtent is true, the user will be able to zoom out so that the viewport exceeds the height or width of the configured extent, but not both, allowing the full extent to be shown.

- ##### Optional smoothExtentConstraint?: boolean

  If true, the extent constraint will be applied smoothly, i.e. allow the view to go slightly outside of the given `extent`.

- ##### Optional smoothResolutionConstraint?: boolean

  If true, the resolution min/max values will be applied smoothly, i. e. allow the view to exceed slightly the given resolution or zoom bounds.

- ##### Optional zoom?: number

  Only used if `resolution` is not defined. Zoom level used to calculate the initial resolution for the view.

- ##### Optional zoomFactor?: number

  The zoom factor used to compute the corresponding resolution.

### WfsType

WfsType: { defaultFeatureNS?: string; defaultFeaturePrefix?: string; featureNS?: string; featurePrefix?: string; featureType: string; label?: string }

- Defined in config.ts:369

A WFS type. To be used with {@link WfsPermalinkOptions }.

#### Type declaration

- ##### Optional defaultFeatureNS?: string

  The default namespace URI used for features. This will be used if no custom namespace is given for a WFS type.

- ##### Optional defaultFeaturePrefix?: string

  The default prefix for the feature namespace. This will be used if no custom prefix is given for a WFS type.

- ##### Optional featureNS?: string

  The namespace URI used for features. If not given, the default namespace set in {@link WfsPermalinkOptions } will be used.

- ##### Optional featurePrefix?: string

  The prefix for the feature namespace. If not given, the default prefix set in {@link WfsPermalinkOptions } will be used.

- ##### featureType: string

  The feature type name. Required.

- ##### Optional label?: string

  The field of a feature used as label.

### authenticationBaseUrl

authenticationBaseUrl: string

- Defined in config.ts:578

URL to the authentication web service.

### defaultLang

defaultLang: string

- Defined in config.ts:613

Default language

### fulltextsearchUrl

fulltextsearchUrl: string

- Defined in config.ts:583

URL to the full-text search web service.

### gmfAuthenticationConfig

gmfAuthenticationConfig: { allowPasswordChange: boolean; allowPasswordReset: boolean }

- Defined in config.ts:972

The Authentication configuration.

#### Type declaration

- ##### allowPasswordChange: boolean

  Whether to show the change password button. Default to true. You can also specify a `PasswordValidator` object to add constraint on user's new password.

- ##### allowPasswordReset: boolean

  Whether to show the password forgotten link. Default to true.

### gmfAuthenticationNoReloadRole

gmfAuthenticationNoReloadRole: string | null

- Defined in config.ts:1001

Don't request a new user object from the back-end after logging out if the logged-in user's role has this role.

### gmfBackgroundLayerSelectorOptions

gmfBackgroundLayerSelectorOptions: { opacityLayer?: string }

- Defined in config.ts:1011

The background layer selector options

#### Type declaration

- ##### Optional opacityLayer?: string

  The background layer with an opacity slider.

### gmfContextualDataOptions

gmfContextualDataOptions: { projections: string[]; rasterParams: {} }

- Defined in config.ts:841

#### Type declaration

- ##### projections: string[]

- ##### rasterParams: {}

  The raster service parameters

  - ##### [x: string]: string

### gmfCsvFilename

gmfCsvFilename: string

- Defined in config.ts:1006

The CSV file name.

### gmfCustomCSS

gmfCustomCSS: { authentication: string; authenticationPanel: string; desktopCanvas: string; lidarFooter: string; lidarPanel: string }

- Defined in config.ts:1367

Additional CSS for the different elements

#### Type declaration

- ##### authentication: string

- ##### authenticationPanel: string

- ##### desktopCanvas: string

- ##### lidarFooter: string

- ##### lidarPanel: string

### gmfCustomJavascriptUrl

gmfCustomJavascriptUrl: string | string[]

- Defined in config.ts:1352

Use to inject custom javascript from an URL.

### gmfCustomStylesheetUrl

gmfCustomStylesheetUrl: string | string[]

- Defined in config.ts:1357

Use to inject custom stylesheet from an URL.

### gmfDisclaimerOptions

gmfDisclaimerOptions: { external?: boolean; layerVisibility?: boolean; popup?: boolean }

- Defined in config.ts:1021

The disclaimers options

#### Type declaration

- ##### Optional external?: boolean

  Whether to use disclaimer messages elsewhere or not. Default to `false`. If true, you should use the externalMessage and the externalVisibility too.

- ##### Optional layerVisibility?: boolean

  Only display the disclaimer if the layer is visible. Defaults to `true`.

- ##### Optional popup?: boolean

  Whether to show the disclaimer messages in popups or not. Defaults to `false`.

### gmfDisplayQueryGridOptions

gmfDisplayQueryGridOptions: { featuresStyle: StyleLike; maxRecenterZoom?: number; mergeTabs?: GridMergeTabs; removeEmptyColumns?: boolean; selectedFeatureStyle: StyleLike }

- Defined in config.ts:1067

The display querry grid component options.

#### Type declaration

- ##### featuresStyle: StyleLike

  A style object for all features from the result of the query.

- ##### Optional maxRecenterZoom?: number

  Maximum zoom-level to use when zooming to selected features.

- ##### Optional mergeTabs?: GridMergeTabs

  Configuration to merge grids with the same attributes into a single grid.

- ##### Optional removeEmptyColumns?: boolean

  Should empty columns be hidden? Default: `false`.

- ##### selectedFeatureStyle: StyleLike

  A style object for the currently selected features.

### gmfDisplayQueryWindowOptions

gmfDisplayQueryWindowOptions: { collapsed?: boolean; featuresStyle: StyleLike; selectedFeatureStyle: StyleLike }

- Defined in config.ts:1094

The display querry grid component options.

#### Type declaration

- ##### Optional collapsed?: boolean

  If the query result window is collapsed.

- ##### featuresStyle: StyleLike

  A style object for all features from the result of the query.

- ##### selectedFeatureStyle: StyleLike

  A style object for the currently selected features.

### gmfEditFeatureOptions

gmfEditFeatureOptions: { closeAfterSave: boolean; highlightStyle: StyleLike; tolerance: number }

- Defined in config.ts:1333

#### Type declaration

- ##### closeAfterSave: boolean

  If true, immediately return to the main edit panel after save. Default is false.

- ##### highlightStyle: StyleLike

  A style object for highlighting of feature.

- ##### tolerance: number

  The buffer in pixels to use when making queries to get the features.

### gmfElevationOptions

gmfElevationOptions: { layers: string[]; layersConfig: {} }

- Defined in config.ts:1119

The elevation (raster) options.

#### Type declaration

- ##### layers: string[]

  Elevation layers to use.

- ##### layersConfig: {}

  Elevation layers configurations.

  - ##### [x: string]: LayerConfig

### gmfExternalOGCServers

gmfExternalOGCServers: ExternalOGCServer[]

- Defined in config.ts:993

### gmfFloors

gmfFloors: {}[]

- Defined in config.ts:965

Floor dimension values and labels.

### gmfLayerTreeOptions

gmfLayerTreeOptions: { isExpanded: boolean; openlinksinnewwindow: boolean }

- Defined in config.ts:1314

#### Type declaration

- ##### isExpanded: boolean

  [Experimental] Whether all the layer group is expanded by default.

- ##### openlinksinnewwindow: boolean

  if true, open metadataURLs in a new window. Otherwise open them in a popup.

### gmfLayersUrl

gmfLayersUrl: string

- Defined in config.ts:603

URL to the layers web service.

### gmfMobileMeasureAreaOptions

gmfMobileMeasureAreaOptions: { precision?: number; sketchStyle: StyleLike }

- Defined in config.ts:1266

#### Type declaration

- ##### Optional precision?: number

  The number of significant digits to display.

- ##### sketchStyle: StyleLike

  A style for the measure area.

### gmfMobileMeasureLengthOptions

gmfMobileMeasureLengthOptions: { precision?: number; sketchStyle: StyleLike }

- Defined in config.ts:1277

#### Type declaration

- ##### Optional precision?: number

  The number of significant digits to display.

- ##### sketchStyle: StyleLike

  A style for the measure length.

### gmfMobileMeasurePointOptions

gmfMobileMeasurePointOptions: { decimals: number; format: string; rasterLayers: MeasureRasterLayer[]; sketchStyle: StyleLike }

- Defined in config.ts:1294

#### Type declaration

- ##### decimals: number

  The number of significant digits to display.

- ##### format: string

  The used formatter

- ##### rasterLayers: MeasureRasterLayer[]

  Raster elevation layers to get information under the point and its configuration.

- ##### sketchStyle: StyleLike

  A style for the measure point.

### gmfMousePositionOptions

gmfMousePositionOptions: { projections: MousePositionProjection[] }

- Defined in config.ts:1259

#### Type declaration

- ##### projections: MousePositionProjection[]

  The list of the projections.

### gmfObjectEditingToolsOptions

gmfObjectEditingToolsOptions: { regularPolygonRadius?: number }

- Defined in config.ts:854

Additional configuration options for the object editing tools directive.

#### Type declaration

- ##### Optional regularPolygonRadius?: number

  The radius of the shapes created by the regular polygon radius creation tool. The value is in map units.

### gmfOptions

gmfOptions: { controlZoom: OlControlZoomOptions; cssVars: {}; geolocalisation?: boolean; interationDefaults?: OlInteractionDefaultsOptions; map: MapConfig; mapControls?: OlControlControl[]; mapInteractions?: OlInteractionInteraction[]; showInfobar?: boolean; view: View; zoom: number }

- Defined in config.ts:783

The application wide options.

#### Type declaration

- ##### controlZoom: OlControlZoomOptions

  The zoom control options

- ##### cssVars: {}

  The css variables, in particular brand-primary and brand-secondary that will set all the branding.

  - ##### [x: string]: string

- ##### Optional geolocalisation?: boolean

  Show the geolocalisation button.

- ##### Optional interationDefaults?: OlInteractionDefaultsOptions

  The map interactions.

- ##### map: MapConfig

  The map definition.

- ##### Optional mapControls?: OlControlControl[]

  The map control.

- ##### Optional mapInteractions?: OlInteractionInteraction[]

  The map interactions.

- ##### Optional showInfobar?: boolean

  Show the information bar.

- ##### view: View

  The view definition.

- ##### zoom: number

  The default zoom.

### gmfPermalinkOptions

gmfPermalinkOptions: { crosshairEnabledByDefault?: boolean; crosshairStyle?: StyleLike; pointRecenterZoom?: number; projectionCodes?: string[]; useLocalStorage?: boolean }

- Defined in config.ts:865

Configuration options for the permalink service.

#### Type declaration

- ##### Optional crosshairEnabledByDefault?: boolean

  Display the crosshair, gets overridden by the `map_crosshair` parameter. Default is `false`.

- ##### Optional crosshairStyle?: StyleLike

  An alternate style for the crosshair feature added by the permalink service.

- ##### Optional pointRecenterZoom?: number

  Zoom level to use when result is a single point feature. If not set the map is not zoomed to a specific zoom level.

- ##### Optional projectionCodes?: string[]

  EPSG codes (e.g. 'EPSG:3857' or '3857'). The permalink service will accept coordinates in these projections and try to detect which projection the given coordinates are in.

- ##### Optional useLocalStorage?: boolean

  Store the values in the local storage. Default is `false`.

### gmfPrintOptions

gmfPrintOptions: { defaultLayout?: string; fieldValues?: {}; goodnessOfFit?: number; hiddenAttributes?: string[]; legend?: OptionsLegendType; rotateMask?: boolean; scaleInput?: boolean }

- Defined in config.ts:923

#### Type declaration

- ##### Optional defaultLayout?: string

- ##### Optional fieldValues?: {}

  optional. Key, value object to define default value in each of your print panel field. The key refers to the property's name of the field. Example: {'comments': 'demo', 'legend': false}. Doesn't work for the DPI and the scale. Server's values are used in priority.

  - ##### [x: string]: string | number | boolean

- ##### Optional goodnessOfFit?: number

- ##### Optional hiddenAttributes?: string[]

  The list of attributes that should be hidden.

- ##### Optional legend?: OptionsLegendType

  Options used to build the legend.

- ##### Optional rotateMask?: boolean

  True to apply rotation on the mask instead of the map. By default, the map rotates.

- ##### Optional scaleInput?: boolean

### gmfPrintUrl

gmfPrintUrl: string

- Defined in config.ts:608

URL to MapFishPrint.

### gmfProfileJsonUrl

gmfProfileJsonUrl: string

- Defined in config.ts:598

URL to the profile web service.

### gmfProfileOptions

gmfProfileOptions: { hoverPointStyle: StyleLike; numberOfPoints?: number }

- Defined in config.ts:1135

The elevation (raster) options.

#### Type declaration

- ##### hoverPointStyle: StyleLike

  The hover point style.

- ##### Optional numberOfPoints?: number

  Maximum limit of points to request.

### gmfProjectionsOptions

gmfProjectionsOptions: {}

- Defined in config.ts:832

The available projections definitions.

#### Type declaration

- ##### [x: string]: Projection

### gmfQueryGrid

gmfQueryGrid: boolean

- Defined in config.ts:1062

Use the query grid instead the query window to display the query result.

### gmfRasterUrl

gmfRasterUrl: string

- Defined in config.ts:593

URL to the raster web service.

### gmfSearchGroups

gmfSearchGroups: string[]

- Defined in config.ts:995

### gmfSearchOptions

gmfSearchOptions: { clearButton?: boolean; colorChooser?: boolean; coordinatesProjections: string[]; datasources: SearchComponentDatasource[]; delay?: number; maxZoom?: number; placeholder?: string; styles: {} }

- Defined in config.ts:1198

#### Type declaration

- ##### Optional clearButton?: boolean

  Clear button in the input search.

- ##### Optional colorChooser?: boolean

  Whether to let the user change the style of the feature on the map.

- ##### coordinatesProjections: string[]

  codes of supported projections for coordinates search (projections must be defined in ol3). If not provided, only the map's view projection format will be supported.

- ##### datasources: SearchComponentDatasource[]

  The used datasources.

- ##### Optional delay?: number

  bloodhound request delay in ms.

- ##### Optional maxZoom?: number

  maximum zoom we will zoom on result.

- ##### Optional placeholder?: string

  The placeholder.

- ##### styles: {}

  A map of styles to apply on searched features. Keys must be the 'layer_name' property of features except for coordinates where the key ifor its style is the value of the constant 'gmf.COORDINATES_LAYER_NAME'. The 'default' key is used to apply the default style.

  - ##### [x: string]: StyleLike

### gmfShareOptions

gmfShareOptions: { enableEmail?: boolean }

- Defined in config.ts:1326

#### Type declaration

- ##### Optional enableEmail?: boolean

  Enhable email.

### gmfShortenerCreateUrl

gmfShortenerCreateUrl: string

- Defined in config.ts:588

URL to the shortener web service.

### gmfSnappingOptions

gmfSnappingOptions: { maxFeatures: number }

- Defined in config.ts:1042

The snapping options

#### Type declaration

- ##### maxFeatures: number

  The max number of features in the extent to allows snapping

### gmfThemesOptions

gmfThemesOptions: { addBlankBackgroundLayer?: boolean }

- Defined in config.ts:954

Configuration options for the themes service.

#### Type declaration

- ##### Optional addBlankBackgroundLayer?: boolean

  Whether to add a blank background layer to the list of available backgrounds.

### gmfTreeManagerModeFlush

gmfTreeManagerModeFlush: boolean

- Defined in config.ts:839

Flush mode active?

### gmfTreeUrl

gmfTreeUrl: string

- Defined in config.ts:573

URL to the theme web service.

### gmfTwoFactorAuth

gmfTwoFactorAuth: boolean

- Defined in config.ts:1362

Does the application use tow factor authentication

### langUrls

langUrls: {}

- Defined in config.ts:618

Languages URL

#### Type declaration

- ##### [x: string]: string

### ngeoCsvEncoding

ngeoCsvEncoding: string

- Defined in config.ts:434

File encoding of the CSV file.

### ngeoCsvExtension

ngeoCsvExtension: string

- Defined in config.ts:439

File extension of the CSV file.

### ngeoCsvIncludeHeader

ngeoCsvIncludeHeader: boolean

- Defined in config.ts:444

Whether to include the header in the exported file or not.

### ngeoCsvQuote

ngeoCsvQuote: string

- Defined in config.ts:449

Quote character.

### ngeoCsvSeparator

ngeoCsvSeparator: string

- Defined in config.ts:454

Separator character.

### ngeoGeolocationOptions

ngeoGeolocationOptions: { accuracyFeatureStyle?: StyleLike; atLoadingTime?: boolean; autoRotate?: boolean; positionFeatureStyle?: StyleLike; zoom?: number }

- Defined in config.ts:522

Options for the geolocation directive.

#### Type declaration

- ##### Optional accuracyFeatureStyle?: StyleLike

  The style to use to sketch the accuracy feature, which is a regular polygon.

- ##### Optional atLoadingTime?: boolean

  Toggle geolocating at loading time if true.

- ##### Optional autoRotate?: boolean

  Autorotate.

- ##### Optional positionFeatureStyle?: StyleLike

  The style to use to sketch the position feature, which is a point.

- ##### Optional zoom?: number

  If set, in addition to recentering the map view at the location, determines the zoom level to set when obtaining a new position

### ngeoMeasureDecimals

ngeoMeasureDecimals: number

- Defined in config.ts:423

### ngeoMeasurePrecision

ngeoMeasurePrecision: number

- Defined in config.ts:421

### ngeoMeasureSpherical

ngeoMeasureSpherical: boolean

- Defined in config.ts:425

### ngeoNominatimSearchDefaultParams

ngeoNominatimSearchDefaultParams: {}

- Defined in config.ts:263

#### Type declaration

- ##### [x: string]: string

### ngeoOfflineTestUrl

ngeoOfflineTestUrl: string

- Defined in config.ts:256

URL of the test page to detect online/offline.

### ngeoPermalinkOgcserverUrl

ngeoPermalinkOgcserverUrl: string

- Defined in config.ts:261

URL to the WFS server.

### ngeoPointfilter

ngeoPointfilter: string

- Defined in config.ts:429

### ngeoProfileOptions

ngeoProfileOptions: { light?: boolean; lightXAxis?: boolean; linesConfiguration: {}; poiLabelAngle?: number; styleDefs?: string }

- Defined in config.ts:493

Options for the profile.

#### Type declaration

- ##### Optional light?: boolean

  Show a simplified profile when true.

- ##### Optional lightXAxis?: boolean

  Show a simplified x axis with only both end ticks.

- ##### linesConfiguration: {}

  Configuration object for the profile's

  - ##### [x: string]: LineConfiguration

- ##### Optional poiLabelAngle?: number

  Inline CSS style definition to inject in the SVG. lines. The key string of each object is used as class for its respective svg line.

- ##### Optional styleDefs?: string

  Inline CSS style definition to inject in the SVG.

### ngeoQueryOptions

ngeoQueryOptions: { bboxAsGETParam?: boolean; cursorHover?: boolean; featureNS?: string; featurePrefix?: string; geometryName?: string; limit?: number; queryCountFirst?: boolean; sourceIdsProperty?: string; tolerance?: number; toleranceTouch?: number }

- Defined in config.ts:270

The options for the query service.

#### Type declaration

- ##### Optional bboxAsGETParam?: boolean

  Pass the queried bbox as a parameter of the GET query on WFS requests.

- ##### Optional cursorHover?: boolean

- ##### Optional featureNS?: string

  The feature namespace for WFS GetFeature requests.

- ##### Optional featurePrefix?: string

  The feature prefix for WFS GetFeature requests.

- ##### Optional geometryName?: string

  The name of the geometry property for WFS GetFeature requests.

- ##### Optional limit?: number

  The maximum number of records per request the query service should ask. Note that sources sharing the same URL are combined together in a single request. This limit will still apply to those.

- ##### Optional queryCountFirst?: boolean

  For WFS sources, should the number of features first be requested with `resultType=hits` before requesting the actual features in an seconds request?

- ##### Optional sourceIdsProperty?: string

  Defines the name of the layer property that holds the ids of the sources. Use this if you have more than one source bound to a layer.

- ##### Optional tolerance?: number

  When issuing an identify feature request at a click position, either a WMS GetFeatureInfo or a WFS GetFeature request will be used. For GetFeature requests a bbox is built around the position. This `tolerance` in pixel determines the minimal size of the bbox.

- ##### Optional toleranceTouch?: number

  Same as `tolerance` but for touch devices.

### ngeoRoutingOptions

ngeoRoutingOptions: { backendUrl?: string; profiles?: RoutingProfile[] }

- Defined in config.ts:324

#### Type declaration

- ##### Optional backendUrl?: string

- ##### Optional profiles?: RoutingProfile[]

### ngeoScaleSelectorOptions

ngeoScaleSelectorOptions: { dropup?: boolean; values: number[] }

- Defined in config.ts:459

The scale selector options

#### Type declaration

- ##### Optional dropup?: boolean

  True to get a drop menu that opens imself to the top, instead of the bottom.

- ##### values: number[]

  The available scales

### ngeoSnappingTolerance

ngeoSnappingTolerance: number

- Defined in config.ts:427

### ngeoStreetviewOptions

ngeoStreetviewOptions: { bufferSize?: number; key: string; viewer: string }

- Defined in config.ts:551

Configuration object for streetview.

#### Type declaration

- ##### Optional bufferSize?: number

  Buffer size for Mapillary bbox

- ##### key: string

  ClientId for Mapillary

- ##### viewer: string

  The viewer to use (google or mapillary)

### ngeoStringToHtmlReplacements

ngeoStringToHtmlReplacements: StringToHtmlReplacement[]

- Defined in config.ts:351

List of replacements for string to html.

### ngeoTilesPreloadingLimit

ngeoTilesPreloadingLimit: number

- Defined in config.ts:359

Load tiles up to preload levels. By default preload is Infinity, which means load all tiles on the top of the visible level. See also preload value in documentation for ol.Layer.Tile.

### ngeoUsedKeyRegexp

ngeoUsedKeyRegexp: string[]

- Defined in config.ts:364

Regexp used to identify the used keys.

### ngeoWfsPermalinkOptions

ngeoWfsPermalinkOptions: { defaultFeatureNS: string; defaultFeaturePrefix: string; maxFeatures?: number; pointRecenterZoom?: number; wfsTypes: WfsType[] }

- Defined in config.ts:403

The options for the WFS query service (permalink).

#### Type declaration

- ##### defaultFeatureNS: string

- ##### defaultFeaturePrefix: string

- ##### Optional maxFeatures?: number

  The maximum number of records per request the query service should ask.

- ##### Optional pointRecenterZoom?: number

  Zoom level to use when result is a single point feature. If not set the map is not zoomed to a specific zoom level.

- ##### wfsTypes: WfsType[]

  The queryable WFS types.

### pytreeLidarprofileJsonUrl

pytreeLidarprofileJsonUrl: string

- Defined in config.ts:1378

URL to LIDAR profile pytree service.

## Variables

### Const default

default: ConfigModel = ...

- Defined in config.ts:1509

## Functions

### buildStyle

- buildStyle(styleDescriptor: StyleLike): OlStyleStyleStyleLike

- - Defined in config.ts:194

  #### Parameters

  - ##### styleDescriptor: StyleLike

    The description of the style

  #### Returns OlStyleStyleStyleLike

  The OpenLayers stale

Generated using TypeDoc